using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using FineBytes.MEX.Explorer;

namespace FineBytes.MEX.ExplorerDemo
{
	/// <summary>
	/// Summary description for SpecFolderForm.
	/// </summary>
	public class SpecFolderForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListBox lbSpecialFolders;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private FileExplorer mFileExplorer;

		public SpecFolderForm(FileExplorer FileExplorer_)
		{
			InitializeComponent();
			mFileExplorer = FileExplorer_;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.lbSpecialFolders = new System.Windows.Forms.ListBox();
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// lbSpecialFolders
			// 
			this.lbSpecialFolders.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lbSpecialFolders.Location = new System.Drawing.Point(0, 0);
			this.lbSpecialFolders.Name = "lbSpecialFolders";
			this.lbSpecialFolders.Size = new System.Drawing.Size(320, 212);
			this.lbSpecialFolders.TabIndex = 0;
			this.lbSpecialFolders.DoubleClick += new System.EventHandler(this.lbSpecialFolders_DoubleClick);
			// 
			// btnOK
			// 
			this.btnOK.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.btnOK.Location = new System.Drawing.Point(64, 232);
			this.btnOK.Name = "btnOK";
			this.btnOK.Size = new System.Drawing.Size(80, 23);
			this.btnOK.TabIndex = 1;
			this.btnOK.Text = "&OK";
			this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.btnCancel.Location = new System.Drawing.Point(160, 232);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.Size = new System.Drawing.Size(88, 23);
			this.btnCancel.TabIndex = 2;
			this.btnCancel.Text = "&Cancel";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// SpecFolderForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(320, 270);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.lbSpecialFolders);
			this.Name = "SpecFolderForm";
			this.Text = "Navigate to Special Folder";
			this.Load += new System.EventHandler(this.SpecFolderForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void SpecFolderForm_Load(object sender, System.EventArgs e)
		{
			foreach (SpecialFolder ssf in Enum.GetValues(typeof(SpecialFolder)))
			{
				lbSpecialFolders.Items.Add (ssf.ToString());
			}		
		}

		private void MoveTo()
		{
			if (lbSpecialFolders.SelectedItem == null) return;
			string ssfName = lbSpecialFolders.SelectedItem.ToString();
			SpecialFolder ssf = (SpecialFolder)Enum.Parse(typeof(SpecialFolder), ssfName);	
			try
			{
				mFileExplorer.MoveToSpecialFolder(ssf);
			}
			catch
			{
				// folder may not exist or the OS may not support this special folder value
				MessageBox.Show ("Could not browse to this special folder", "Error");
			}
		}

		private void lbSpecialFolders_DoubleClick(object sender, System.EventArgs e)
		{
			MoveTo();
		}

		private void btnOK_Click(object sender, System.EventArgs e)
		{
			MoveTo();
			Close();
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			Close();
		}

	}
}
